#!/usr/bin/perl

$chordprog = "/home/rickheit/public_html/chord/ch/ch";
$prog = $ENV{SCRIPT_NAME} || 'chr.cgi';
%arg = &cgi_handle;

# collect string names
if ($arg{s1})
{
  for $i (0..5)
    { push @strings, $arg{"s$i"} unless $arg{"s$i"} eq 'x'; }
}
else
{
  @strings = qw(E A D G B E);
}

# build our list of string pulldowns
@slist = qw(x A B C D E F G A# B# C# D# E# F# G# Ab Bb Cb Db Eb Fb Gb);
for $i (0..5)
{
  $s = shift @strings || 'x';
  $buf = qq(<SELECT NAME="s$i">);
  for (@slist)
  {
    $buf .= "<OPTION";
    $buf .= " SELECTED" if $s eq $_;
    $buf .= ">$_";
  }
  $buf .= qq(</SELECT>\n);
  $slist .= $buf;
  push @svals, $s unless $s eq 'x';
}

# do we have a chord to figure?
if ($arg{chord})
{
  $results = "<HR><TABLE>\n";
  open(PR, "|$chordprog -r4 -i3 -p4 -t @svals . > /tmp/chr.$$");
  print PR "$arg{chord}\n";
  close(PR);
  open(IN, "/tmp/chr.$$");
  while (<IN>)
  {
    @a = split;
    push @lines, [ @a ];
  }
  close(IN);
  unlink("/tmp/chr.$$");

  # sort those voicings by base fret
  @lines = sort { $$a[$#$a] <=> $$b[$#$b] } @lines;

  while ($l = shift @lines)
  {
    $count++;
    if ($count == 1) { $results .= "<TR>\n"; }
    $name = shift @$l; $fret = pop @$l;
    $fret = '' if $fret < 2;
    $n = shift @$l;
    $results .= qq(<TD ALIGN=CENTER>$name<BR>\n$fret<IMG ALIGN=TOP SRC="ch${n}l.gif" ALT="-$n">);
    while (@$l > 1)
    {
      $n = shift @$l;
      $results .= qq(<IMG ALIGN=TOP SRC="ch${n}m.gif" ALT="$n">);
    }
    $n = shift @$l;
    $results .= qq(<IMG ALIGN=TOP SRC="ch${n}r.gif" ALT="$n-">\n</TD>\n);
    if ($count == 8) { $count = 0; $results .= "</TR>\n"; }
  }
  if ($count) { $results .= "</TR>\n"; }
  $results .= "</TABLE>\n";
}


# generate the page
print <<EOF;
Content-Type: text/html

<HTML><HEAD><TITLE>Chord Voicings</TITLE></HEAD>
<BODY><CENTER>
<H3>Chord Voicings</H3>
This program attempts to find all the possible voicings of a given
chord, within limits I hope are reasonable. Not all the chords it finds
may be playable; its knowledge of the anatomy of the hand is limited
to the number of fingers (4) and the number of frets one can easily
reach (4). Also, the chord parser is probably incomplete, but it should
recognize things like 'Am', or 'Edim7' or 'C#/D' or 'A add 7' or 'C6/9'
adequately. You can choose an alternate tuning, or find chords for different
instruments.

<FORM METHOD=POST ACTION="$prog">
Chord to find: <INPUT NAME="chord" VALUE="$arg{chord}"><BR>
Choose an alternate tuning:<BR>
$slist<BR>
<INPUT TYPE=SUBMIT VALUE=" Find Voicings ">
</FORM>
$results
</CENTER></BODY></HTML>
EOF

sub cgi_handle
{ local(@a);

  if ($ENV{'REQUEST_METHOD'} eq 'POST')
    { ($stuff = <>) =~ s/^\s*|\s*$//g; }
  else
    { $stuff = $ENV{'QUERY_STRING'}; }

  @a = split(/[\&\=]/, $stuff);
  for (@a)
  {
    s/\+/ /g;
    s/%(..)/sprintf("%c", hex($1))/eg;
  }
  return @a;
}

